/*
 File: test_called_thd_fssym.cpp
 Date and Time: Mon Oct 13 18:18:16 2014 
*/
#include "test_called_thd_fs.h"
using namespace NS_yacco2_T_enum;// enumerate
using namespace NS_yacco2_err_symbols;// error symbols
using namespace NS_yacco2_k_symbols;// lrk 
using namespace NS_yacco2_terminals;// terminals
using namespace NS_yacco2_characters;// rc 
using namespace yacco2;// yacco2 library
using namespace NS_test_called_thd_fs;// grammar's ns
// first set terminals
yacco2::THR _YACCO2_CALL_TYPE
NS_test_called_thd_fs::TH_test_called_thd_fs(yacco2::Parser* Caller_pp){
  yacco2::Thread_entry& pp_thread_entry = ITH_test_called_thd_fs;
  NS_test_called_thd_fs::Ctest_called_thd_fs Ctest_called_thd_fs_;// parallel-parser's parse table
#define ssPARSE_TABLE Ctest_called_thd_fs_
#include "wpp_core.h"
}
THR_result _YACCO2_CALL_TYPE
NS_test_called_thd_fs::PROC_TH_test_called_thd_fs(yacco2::Parser* Caller_pp){
  char called_proc_name[] = "PROC_TH_test_called_thd_fs";
  static bool one_time(false);
  static NS_test_called_thd_fs::Ctest_called_thd_fs* NS_test_called_thd_fs_Ctest_called_thd_fs_(0);// parallel-parser's fsm table
  static Parser* NS_test_called_thd_fs_Ctest_called_thd_fs_parser(0);
  Parser* proc_parser(0);
  if(one_time == false){
    one_time = true;
    NS_test_called_thd_fs_Ctest_called_thd_fs_ = new NS_test_called_thd_fs::Ctest_called_thd_fs();// parallel-parser's fsm table
    NS_test_called_thd_fs_Ctest_called_thd_fs_parser = new Parser(*NS_test_called_thd_fs_Ctest_called_thd_fs_,Caller_pp);
  }
 proc_parser = NS_test_called_thd_fs_Ctest_called_thd_fs_parser;
#include "wproc_pp_core.h"
}
void 
Ctest_called_thd_fs::reduce_rhs_of_rule
    (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule){
   int reducing_rule = rhs_to_rules_mapping_[Sub_rule_no];
   Per_rule_s_reuse_table* rule_reuse_tbl_ptr = 
        fsm_rules_reuse_table.per_rule_s_table_[reducing_rule];
   Rule_s_reuse_entry* re(0);
   find_a_recycled_rule(rule_reuse_tbl_ptr,&re);
   (*Recycled_rule) = re;
   fnd_re: switch (Sub_rule_no){
    case rhs1_RSt_:{
       RSt* sym;
     if(re->rule_ == 0){
       sym = new RSt(parser__);
       re->rule_ = sym;
     }else{
       sym = (RSt*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs2_RS_:{
       RS* sym;
     if(re->rule_ == 0){
       sym = new RS(parser__);
       re->rule_ = sym;
     }else{
       sym = (RS*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 3;
    

     return;}
    case rhs1_Ra_:{
       Ra* sym;
     if(re->rule_ == 0){
       sym = new Ra(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ra*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Ra_:{
       Ra* sym;
     if(re->rule_ == 0){
       sym = new Ra(parser__);
       re->rule_ = sym;
     }else{
       sym = (Ra*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rb_:{
       Rb* sym;
     if(re->rule_ == 0){
       sym = new Rb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rb_:{
       Rb* sym;
     if(re->rule_ == 0){
       sym = new Rb(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rb*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Rc_:{
       Rc* sym;
     if(re->rule_ == 0){
       sym = new Rc(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rc*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rc_:{
       Rc* sym;
     if(re->rule_ == 0){
       sym = new Rc(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rc*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    case rhs1_Rd_:{
       Rd* sym;
     if(re->rule_ == 0){
       sym = new Rd(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rd*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 0;
    

     return;}
    case rhs2_Rd_:{
       Rd* sym;
     if(re->rule_ == 0){
       sym = new Rd(parser__);
       re->rule_ = sym;
     }else{
       sym = (Rd*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 2;
    

     return;}
    case rhs1_Re_:{
       Re* sym;
     if(re->rule_ == 0){
       sym = new Re(parser__);
       re->rule_ = sym;
     }else{
       sym = (Re*)re->rule_;
     }
    // no rule's constructor directive
     (*Recycled_rule)->rule_ = sym;
     sym->rule_info__.rhs_no_of_parms__ = 1;
    

     return;}
    default: return;
   }
}
